'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactDom = require('react-dom');

var _reactFlex = require('react-flex');

var _Column = require('../Column');

var _Column2 = _interopRequireDefault(_Column);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Navigation helper is used for navigatin between rows using arrows.
 * When a row will recieve focus, it will trigger focus on NavigationHelper.
 * Doing so we can handle onKeyPress, even if the initial focused row loses focus
 * when is unmounted
 */

var NavigationHelper = function (_Component) {
  _inherits(NavigationHelper, _Component);

  function NavigationHelper() {
    _classCallCheck(this, NavigationHelper);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(NavigationHelper).apply(this, arguments));
  }

  _createClass(NavigationHelper, [{
    key: 'render',
    value: function render() {
      var props = this.props;
      var onBlur = props.onBlur;


      return _react2.default.createElement('div', {
        tabIndex: -1,
        ref: 'navigationHelper',
        className: 'react-datagrid__navigation-helper',
        onBlur: onBlur,
        onKeyDown: this.onKeyDown
      });
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(event) {
      if (event.key === 'ArrowUp') {
        this.props.onArrowUp();
      }

      if (event.key === 'ArrowDown') {
        this.props.onArrowDown();
      }
    }
  }, {
    key: 'focus',
    value: function focus() {
      this.refs.navigationHelper.focus();
    }
  }]);

  return NavigationHelper;
}(_reactClass2.default);

exports.default = NavigationHelper;


NavigationHelper.propTypes = {
  onArrowUp: _react.PropTypes.func,
  onArrowDown: _react.PropTypes.func
};